> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://developer.deel.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://developer.deel.com/_mcp/server.

# Review a single task

POST https://api.letsdeel.com/rest/contracts/{contract_id}/tasks/{task_id}/reviews
Content-Type: application/json

Submits an approval or rejection review for a task associated with a contract. If the review status is declined, an optional reason may be included in the request body.

 **Token scopes**: `contracts:write`

Reference: https://developer.deel.com/api/embedded/ic-endpoints/tasks/create-contract-task-review

## Authentication

- `Authorization` header (bearer token, required) — ## Authentication The Deel API uses bearer tokens to authenticate requests. All API calls must be made over HTTPS — calls over plain HTTP or without authentication will fail. ```curl curl -X GET 'https://api.letsdeel.com/rest/v2/contracts' \ -H 'Authorization: Bearer YOUR-TOKEN-HERE' ``` [Learn more about authentication](/api/authentication)
- `Authorization` header (bearer token, required) — Standard OAuth2 security scheme based on https://swagger.io/docs/specification/authentication/

## Servers

- `https://api.letsdeel.com/rest` (Production, default)
- `https://api-staging.letsdeel.com/rest` (Demo)

## Request

### Path parameters

- `contract_id` (string, required) — The unique Deel contract ID associated with the task.
- `task_id` (string, required) — The unique ID of the task to be reviewed.

### Body (application/json)

This endpoint expects an object.

- `data` (ContractsContractIdTasksTaskIdReviewsPostRequestBodyContentApplicationJsonSchemaData, optional)

## Response

### 201

The task review was successfully processed.

- `data` (ContractsContractIdTasksTaskIdReviewsPostResponsesContentApplicationJsonSchemaData, required)

## Errors

### 400 Bad Request Error

Bad request. Missing required fields or invalid data format.

- `error` (string, optional)

### 401 Unauthorized Error

Unauthorized. Authentication credentials are missing or invalid.

- `error` (string, optional)

### 403 Forbidden Error

Operation failed.

- `request` (ApiErrorRequest, optional)
- `errors` (list of ApiError, optional)

### 404 Not Found Error

Not found. The specified task or contract was not found.

- `error` (string, optional)

### 500 Internal Server Error

Internal server error. An unexpected error occurred while processing the request.

- `error` (string, optional)

## Types

### ContractsContractIdTasksTaskIdReviewsPostRequestBodyContentApplicationJsonSchemaData

- `status` (enum, required) — The review status of the task. Possible values are 'approved' or 'declined'.
  - Allowed values: `approved`, `declined`
- `reason` (string, optional, nullable) — Optional reason for declining the task.

### ContractsContractIdTasksTaskIdReviewsPostResponsesContentApplicationJsonSchemaData

- `created` (boolean, required) — Indicating whether the task review was created

### ApiErrorRequest

- `method` (string, optional) — The HTTP method of the failed request
- `url` (string, optional) — The relative URL of the failed request
- `status` (double, optional) — The status code of the response
- `api_req_id` (string, optional) — The request ID of the failed request
- `docs` (string, optional) — A link to the official documentation for the requested endpoint resource
- `source` (string, optional) — The source handler which produced the returned error
- `code` (double, optional) — The code of the source handler which produced the returned error

### ApiError

- `message` (string, optional) — A description of the returned error
- `path` (string, optional) — The JSON path where input validation failed

## Examples

**Request**

```json
{
  "data": {
    "status": "declined",
    "reason": "Incomplete documentation"
  }
}
```

**Response**

```json
{
  "data": {
    "created": true
  }
}
```

**SDK Code**

```python tasks_createContractTaskReview_example
import requests

url = "https://api.letsdeel.com/rest/contracts/37nex2x/tasks/00000000-0000-0000-0000-000000000000/reviews"

payload = { "data": {
        "status": "declined",
        "reason": "Incomplete documentation"
    } }
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript tasks_createContractTaskReview_example
const url = 'https://api.letsdeel.com/rest/contracts/37nex2x/tasks/00000000-0000-0000-0000-000000000000/reviews';
const options = {
  method: 'POST',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"data":{"status":"declined","reason":"Incomplete documentation"}}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go tasks_createContractTaskReview_example
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.letsdeel.com/rest/contracts/37nex2x/tasks/00000000-0000-0000-0000-000000000000/reviews"

	payload := strings.NewReader("{\n  \"data\": {\n    \"status\": \"declined\",\n    \"reason\": \"Incomplete documentation\"\n  }\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby tasks_createContractTaskReview_example
require 'uri'
require 'net/http'

url = URI("https://api.letsdeel.com/rest/contracts/37nex2x/tasks/00000000-0000-0000-0000-000000000000/reviews")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"data\": {\n    \"status\": \"declined\",\n    \"reason\": \"Incomplete documentation\"\n  }\n}"

response = http.request(request)
puts response.read_body
```

```java tasks_createContractTaskReview_example
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.letsdeel.com/rest/contracts/37nex2x/tasks/00000000-0000-0000-0000-000000000000/reviews")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"data\": {\n    \"status\": \"declined\",\n    \"reason\": \"Incomplete documentation\"\n  }\n}")
  .asString();
```

```php tasks_createContractTaskReview_example
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.letsdeel.com/rest/contracts/37nex2x/tasks/00000000-0000-0000-0000-000000000000/reviews', [
  'body' => '{
  "data": {
    "status": "declined",
    "reason": "Incomplete documentation"
  }
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp tasks_createContractTaskReview_example
using RestSharp;

var client = new RestClient("https://api.letsdeel.com/rest/contracts/37nex2x/tasks/00000000-0000-0000-0000-000000000000/reviews");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"data\": {\n    \"status\": \"declined\",\n    \"reason\": \"Incomplete documentation\"\n  }\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift tasks_createContractTaskReview_example
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = ["data": [
    "status": "declined",
    "reason": "Incomplete documentation"
  ]] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.letsdeel.com/rest/contracts/37nex2x/tasks/00000000-0000-0000-0000-000000000000/reviews")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```